#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFishingCeleGiftLottery.h"
std::auto_ptr<M_ActivityFishingCeleGiftLottery> M_ActivityFishingCeleGiftLottery::msSingleton(nullptr);

int M_ActivityFishingCeleGiftLottery::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleGiftLotteryData* M_ActivityFishingCeleGiftLottery::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFishingCeleGiftLotteryData>& M_ActivityFishingCeleGiftLottery::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleGiftLottery::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFishingCeleGiftLottery.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleGiftLotteryData data;
		data.mID = element->IntAttribute("ID");
		data.mLotteryCount = element->IntAttribute("LotteryCount");
		{
			const char* rewardItem = element->Attribute("rewardItem");
			std::vector<std::string> vecrewardItem;
			boost::split(vecrewardItem, rewardItem, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecrewardItem.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecrewardItem[i].c_str(), &temp))
				{
					data.mrewardItem.push_back(temp);
				}
			}
		}
		{
			const char* rewardCount = element->Attribute("rewardCount");
			std::vector<std::string> vecrewardCount;
			boost::split(vecrewardCount, rewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecrewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecrewardCount[i].c_str(), &temp))
				{
					data.mrewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFishingCeleGiftLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleGiftLottery::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFishingCeleGiftLottery");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFishingCeleGiftLottery");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFishingCeleGiftLotteryData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "LotteryCount", data.mLotteryCount);
		LuaCfgHelper::readVectorInt(L, "rewardItem", data.mrewardItem);
		LuaCfgHelper::readVectorInt(L, "rewardCount", data.mrewardCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFishingCeleGiftLottery Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleGiftLottery::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFishingCeleGiftLottery* M_ActivityFishingCeleGiftLottery::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleGiftLottery());
	}
	return msSingleton.get();
}

void M_ActivityFishingCeleGiftLottery::Release()
{
	msSingleton.reset(nullptr);
}
